//
//  File.swift
//  
//
//  Created by Malcolm Anderson on 6/8/21.
//

import Foundation


public struct NoOp: RMCCommand {
    public var id = 0
    public var argArray: [Double] {[]}
}

public struct ClearFaults: RMCCommand {
    public var id = 4
    public var argArray: [Double] {[]}
}

public struct EnableController: RMCCommand {
    public var id = 7
    public var argArray: [Double] {[]}
}

public struct FaultController: RMCCommand {
    public var id = 8
    public var argArray: [Double] {[]}
}

public struct SetEnableOutput: RMCCommand {
    public var id = 67
    
    public var enable: Bool
    
    public init(to state: Bool) {
        self.enable = state
    }
    
    public var argArray: [Double] {[self.enable ? 1.0 : 0.0]}
}

public struct EnableOrDisableAxis: RMCCommand {
    public var id = 97
    
    public var enable: Bool
    
    public init(to state: Bool) {
        self.enable = state
    }
    
    public var argArray: [Double] {[self.enable ? 1.0 : 0.0]}
}

public struct RUNMode: RMCCommand {
    public var id = 98
    public var argArray: [Double] {[]}
}

public struct PROGRAMMode: RMCCommand {
    public var id = 99
    public var argArray: [Double] {[]}
}
