//
//  File.swift
//  
//
//  Created by Malcolm Anderson on 6/8/21.
//

import Foundation

public struct DirectOutput: RMCCommand {
    public var id = 9
    
    public var output: Double
    public var rampRate: Double
    
    public init(to output: Double, withRampRate rampRate: Double) {
        self.output = output
        self.rampRate = rampRate
    }
    
    public var argArray: [Double] {[self.output, self.rampRate]}
}

public struct OpenLoopRate: RMCCommand {
    public var id = 10
    
    public var output: Double
    public var rampRate: Double
    
    public init(to output: Double, withRampRate rampRate: Double) {
        self.output = output
        self.rampRate = rampRate
    }
    
    public var argArray: [Double] {[self.output, self.rampRate]}
}

public struct OpenLoopAbsolute: RMCCommand {
    public var id = 11
    
    public var output: Double
    public var position: Double
    public var direction: MovementDirection
    
    public init(output: Double, position: Double, inDirection direction: MovementDirection) {
        self.output = output
        self.position = position
        self.direction = direction
    }
    
    public var argArray: [Double] {[self.output, self.position, self.direction.rawValue]}
}

public struct OpenLoopRelative: RMCCommand {
    public var id = 12
    
    public var output: Double
    public var distance: Double
    
    public init(output: Double, distance: Double) {
        self.output = output
        self.distance = distance
    }
    
    public var argArray: [Double] {[self.output, self.distance]}
}
