//
//  File.swift
//  
//
//  Created by Malcolm Anderson on 6/8/21.
//

import Foundation

public struct StopClosedLoop: RMCCommand {
    public var id = 6
    
    public var decelRate: Double
    
    public init(withDecelRate decelRate: Double) {
        self.decelRate = decelRate
    }
    
    public var argArray: [Double] {[self.decelRate]}
}

public struct StopOpenLoop: RMCCommand {
    public var id = 22
    
    public var rampRate: Double
    
    public init(withRampRate rampRate: Double) {
        self.rampRate = rampRate
    }
    
    public var argArray: [Double] {[self.rampRate]}
}

public struct HoldCurrentPosition: RMCCommand {
    public var id = 5
    
    public var behavior: ControlBehavior
    
    public enum ControlBehavior: Double {
        case standard = 0
        case reset = 1
        case maintain = 2
    }
    
    public init(withControlBehavior behavior: ControlBehavior) {
        self.behavior = behavior
    }
    
    public var argArray: [Double] {[self.behavior.rawValue]}
}

public struct ClosedLoopHalt: RMCCommand {
    public var id = 1
    public var argArray: [Double] {[]}
}

public struct OpenLoopHalt: RMCCommand {
    public var id = 2
    public var argArray: [Double] {[]}
}

public struct DirectOutputHalt: RMCCommand {
    public var id = 3
    public var argArray: [Double] {[]}
}
