//
//  File.swift
//  
//
//  Created by Malcolm Anderson on 6/8/21.
//

import Foundation

public struct SyncMoveAbsolute: RMCCommand {
    public var id = 13
    
    public var position: Double
    public var speed: Double
    public var accelRate: Double
    public var decelRate: Double
    public var direction: MovementDirection
    public var syncGroup: Int
    
    public init(to position: Double, atSpeed speed: Double, withAccelRate accelRate: Double, withDecelRate decelRate: Double, inDirection direction: MovementDirection, withSyncGroup syncGroup: Int) {
        self.position = position
        self.speed = speed
        self.accelRate = accelRate
        self.decelRate = decelRate
        self.direction = direction
        self.syncGroup = syncGroup
    }
    
    public var argArray: [Double] {[self.position, self.speed, self.accelRate, self.decelRate, self.direction.rawValue, Double(self.syncGroup)]}
}

public struct SyncMoveRelative: RMCCommand {
    public var id = 14
    
    public var distance: Double
    public var speed: Double
    public var accelRate: Double
    public var decelRate: Double
    public var relativeTo: RelativeTo
    public var syncGroup: Int
    
    public init(by distance: Double, atSpeed speed: Double, withAccelRate accelRate: Double, withDecelRate decelRate: Double, relativeTo: RelativeTo, withSyncGroup syncGroup: Int) {
        self.distance = distance
        self.speed = speed
        self.accelRate = accelRate
        self.decelRate = decelRate
        self.relativeTo = relativeTo
        self.syncGroup = syncGroup
    }
    
    public var argArray: [Double] {[self.distance, self.speed, self.accelRate, self.decelRate, self.relativeTo.rawValue, Double(self.syncGroup)]}
}

public struct SyncStop: RMCCommand {
    public var id = 17
    
    public var decelRate: Double
    
    public init(withDecelRate decelRate: Double) {
        self.decelRate = decelRate
    }
    
    public var argArray: [Double] {[self.decelRate]}
}

