//
//  File.swift
//  
//
//  Created by Malcolm Anderson on 6/9/21.
//

import Foundation

public struct TransitionDisable: RMCCommand {
    public var id = 55
    public var argArray: [Double] {[]}
}

public struct TransitionRate: RMCCommand {
    public var id = 56
    
    public var maxSpeed: Double
    public var accelRate: Double
    public var transitionType: TransitionType
    public var direction: MovementDirection
    
    public init(withMaxSpeed speed: Double, withAccelRate accelRate: Double, transitionType: TransitionType, inDirection direction: MovementDirection) {
        self.maxSpeed = speed
        self.accelRate = accelRate
        self.transitionType = transitionType
        self.direction = direction
    }
    
    public var argArray: [Double] {[self.maxSpeed, self.accelRate, self.transitionType.rawValue, self.direction.rawValue]}
}
