//
//  File.swift
//  
//
//  Created by Malcolm Anderson on 6/9/21.
//

import Foundation

public struct MoveVelocity: RMCCommand {
    public var id = 37
    
    public var speed: Double
    public var accelRate: Double
    public var decelRate: Double
    public var direction: VelocityDirection
    
    public init(to speed: Double, withAccelRate accelRate: Double, withDecelRate decelRate: Double, inDirection direction: VelocityDirection) {
        self.speed = speed
        self.accelRate = accelRate
        self.decelRate = decelRate
        self.direction = direction
    }
    
    public var argArray: [Double] {[self.speed, self.accelRate, self.decelRate, self.direction.rawValue]}
}

public struct MoveVelocityIPD: RMCCommand {
    public var id = 38
    
    public var speed: Double
    public var direction: VelocityDirection
    
    public init(to speed: Double, inDirection direction: VelocityDirection) {
        self.speed = speed
        self.direction = direction
    }
    
    public var argArray: [Double] {[self.speed, self.direction.rawValue]}
}
