//
//  File.swift
//  
//
//  Created by Malcolm Anderson on 6/9/21.
//

import Foundation

public struct StartPlot: RMCCommand {
    public var id = 100
    
    public var plotNumber: Int
    
    public init(_ plotNumber: Int) {
        self.plotNumber = plotNumber
    }
    
    public var argArray: [Double] {[Double(self.plotNumber)]}
}

public struct StopPlot: RMCCommand {
    public var id = 101
    
    public var plotNumber: Int
    
    public init(_ plotNumber: Int) {
        self.plotNumber = plotNumber
    }
    
    public var argArray: [Double] {[Double(self.plotNumber)]}
}

public struct TriggerPlot: RMCCommand {
    public var id = 102
    
    public var plotNumber: Int
    
    public init(_ plotNumber: Int) {
        self.plotNumber = plotNumber
    }
    
    public var argArray: [Double] {[Double(self.plotNumber)]}
}

public struct RearmPlot: RMCCommand {
    public var id = 103
    
    public var plotNumber: Int
    
    public init(_ plotNumber: Int) {
        self.plotNumber = plotNumber
    }
    
    public var argArray: [Double] {[Double(self.plotNumber)]}
}

public struct EnableDisablePlotTrigger: RMCCommand {
    public var id = 104
    
    public var plotNumber: Int
    public var state: Bool
    
    public init(_ plotNumber: Int, toState state: Bool) {
        self.plotNumber = plotNumber
        self.state = state
    }
    
    public var argArray: [Double] {[Double(self.plotNumber), self.state ? 1.0 : 0.0]}
}
