//
//  File.swift
//  
//
//  Created by Malcolm Anderson on 6/9/21.
//

import Foundation

public struct SetDiscreteOutput: RMCCommand {
    public var id = 60
    
    // TODO: make this more user friendly (may need to change argArray
    // to a function so we can pass in RMC model, in order to calculate
    // integer version of discrete I/O address)
    public var output: Double
    
    public init(_ output: Double) {
        self.output = output
    }
    
    public var argArray: [Double] {[self.output]}
}

public struct ClearDiscreteOutput: RMCCommand {
    public var id = 61
    
    // TODO: make this more user friendly (may need to change argArray
    // to a function so we can pass in RMC model, in order to calculate
    // integer version of discrete I/O address)
    public var output: Double
    
    public init(_ output: Double) {
        self.output = output
    }
    
    public var argArray: [Double] {[self.output]}
}

public struct ToggleDiscreteOutput: RMCCommand {
    public var id = 62
    
    // TODO: make this more user friendly (may need to change argArray
    // to a function so we can pass in RMC model, in order to calculate
    // integer version of discrete I/O address)
    public var output: Double
    
    public init(_ output: Double) {
        self.output = output
    }
    
    public var argArray: [Double] {[self.output]}
}

public struct StartTask: RMCCommand {
    public var id = 90
    
    public var taskNumber: Int
    public var programNumber: Int
    
    public init(_ taskNumber: Int, withProgram programNumber: Int) {
        self.taskNumber = taskNumber
        self.programNumber = programNumber
    }
    
    public var argArray: [Double] {[Double(self.taskNumber), Double(self.programNumber)]}
}

public struct StopTask: RMCCommand {
    public var id = 91
    
    public var taskNumber: Int
    
    public init(_ taskNumber: Int) {
        self.taskNumber = taskNumber
    }
    
    public var argArray: [Double] {[Double(self.taskNumber)]}
}
