//
//  File.swift
//  
//
//  Created by Malcolm Anderson on 6/4/21.
//

import Foundation

extension Data {
    
    mutating func append(_ value: DMCPData) {
        switch value {
        case .int(let integer):
            if integer != nil { self.append(integer!) }
        case .real(let real):
            if real != nil { self.append(real!) }
        }
    }
    
    mutating func append(_ value: UInt16) {
        let newPieceAsData = Swift.withUnsafeBytes(of: value) { Data($0) }
        self.append(newPieceAsData)
    }
    
    mutating func append(_ value: UInt8) {
        let newPieceAsData = Swift.withUnsafeBytes(of: value) { Data($0) }
        self.append(newPieceAsData)
    }
    
    mutating func append(_ value: Int32) {
        let newPieceAsData = Swift.withUnsafeBytes(of: value) { Data($0) }
        self.append(newPieceAsData)
    }
    
    mutating func append(_ value: Float32) {
        let newPieceAsData = Swift.withUnsafeBytes(of: value) { Data($0) }
        self.append(newPieceAsData)
    }

    // from https://stackoverflow.com/a/39075044, for debugging purposes
    var hexDescription: String {
        return reduce("") {$0 + String(format: "%02x ", $1)}
    }
}
