//
//  File.swift
//  
//
//  Created by Malcolm Anderson on 6/16/21.
//

import Foundation

public struct RMCAxis {
    public let id: Int
    public let name: String
    public let axisType: AxisType
    public let primaryInputType: InputType
    public let secondaryInputType: InputType
}

public enum AxisType: Int {
    case none = 0
    case servoPositionControl = 1
    case servoVelocityControl = 3
    case pressureControl = 5
    case forceSingleInputControl = 6
    case forceDualInputDiffControl = 7
    case positionPressureControl = 8
    case positionForceSingleInputControl = 9
    case positionForceDualInputDiffControl = 10
    case velocityPressureControl = 11
    case velocityForceSingleInputControl = 12
    case velocityForceDualInputDiffControl = 13
    case positionReference = 14
    case velocityReference = 15
    case pressureReference = 16
    case forceSingleInputReference = 17
    case forceDualInputDiffReference = 18
    case virtualAxis = 19
    case analogOutputOnly = 20
    case positionAccelSingleInputControl = 22
    case possitionAccelDualInputDiffControl = 23
    case velocityAccelSingleInputControl = 24
    case velocityAccelDualInputDiffControl = 25
    case accelSingleInputReference = 26
    case accelDualInputDiffReference = 27
}

public enum InputType: Int {
    case none = 0
    case position = 1
    case velocity = 2
    case pressure = 3
    case forceSingleInput = 4
    case forceDualInputDiff = 5
    case accelSingleInput = 6
    case accelDualInputDiff = 7
}
