//
//  File.swift
//  
//
//  Created by Malcolm Anderson on 6/22/21.
//

import Foundation

/*
 NOTE: It seems like the RMC's register layout (and available registers, etc)
 is much different from the 70/75/150, and as such there are many addresses that
 it doesn't have. I'm not sure how to handle this...
 */

public class RMC200: RMC {
    public static let displayName: String = "RMC200"
    public static let numberOfAxes = 50
    
    // NOT FOUND
    public static let serialNumberAddr: DMCPAddress? = nil
    //
    
    public static let currentAxisDefinitionsAddr: DMCPAddress? = DMCPAddress(24,0)
    
    // NOT FOUND
    public static let numberOfAllocatedTasksAddr: DMCPAddress? = nil
    //
    
    // NOT FOUND
    public static let controllerNameAddr: DMCPAddress? = nil
    //
    
    // NOT FOUND
    public static let firstAxisNameAddr: DMCPAddress? = nil
    //
    
    public static let firstAxisCommandAddr: DMCPAddress? = DMCPAddress(16,0)
    
    // NOT FOUND
    public static let currentPlotLayoutAddr: DMCPAddress? = nil
    //
    
    public static let maximumPlotsAddr: DMCPAddress? = DMCPAddress(22,1)
    public static let maximumPlotsDataItemsAddr: DMCPAddress? = DMCPAddress(22,2)
    
    
    public static func axisNameAddr(_ axis: Int) -> DMCPAddress? {
        nil
    }
    
    public static func axisCommandAddr(_ axis: Int) -> DMCPAddress? {
        return offsetByArg(firstAxisCommandAddr!, elementBy: axis)
    }
    
    private static func offsetByArg(_ address: DMCPAddress, fileBy file: Int = 0, elementBy element: Int = 0) -> DMCPAddress? {
        var addr = address
        addr.file += UInt16(file)
        addr.element += UInt16(element)
        return addr
    }
    
    public static var firstPlotSamplesAddr: DMCPAddress? = DMCPAddress(512,1)
    public static func plotSamplesAddr(_ plot: Int) -> DMCPAddress? {
        return offsetByArg(firstPlotSamplesAddr!, fileBy: plot)
    }
    
    public static let firstPlotSamplePeriodAddr: DMCPAddress? = DMCPAddress(512,2)
    public static func plotSamplePeriodAddr(_ plot: Int) -> DMCPAddress? {
        return offsetByArg(firstPlotSamplePeriodAddr!, fileBy: plot)
    }
    
    public static var firstPlotAxisOwnerAddr: DMCPAddress? = DMCPAddress(512,3)
    public static func plotAxisOwnerAddr(_ plot: Int) -> DMCPAddress? {
        return offsetByArg(firstPlotAxisOwnerAddr!, fileBy: plot)
    }
    
    public static var firstPlotTriggerPositionAddr: DMCPAddress? = DMCPAddress(512,4)
    public static func plotTriggerPositionAddr(_ plot: Int) -> DMCPAddress? {
        return offsetByArg(firstPlotTriggerPositionAddr!, fileBy: plot)
    }
    
    public static var firstPlotTriggerTypeAddr: DMCPAddress? = DMCPAddress(512,5)
    public static func plotTriggerTypeAddr(_ plot: Int) -> DMCPAddress? {
        return offsetByArg(firstPlotTriggerTypeAddr!, fileBy: plot)
    }
    
    public static var firstPlotIDAddr: DMCPAddress? = DMCPAddress(512,8)
    public static func plotIDAddr(_ plot: Int) -> DMCPAddress? {
        return offsetByArg(firstPlotIDAddr!, fileBy: plot)
    }
    
    public static var firstPlotStateAddr: DMCPAddress? = DMCPAddress(512,9)
    public static func plotStateAddr(_ plot: Int) -> DMCPAddress? {
        return offsetByArg(firstPlotStateAddr!, fileBy: plot)
    }
    
    public static var firstPlotCapturedSamplesAddr: DMCPAddress? = DMCPAddress(512,10)
    public static func plotCapturedSamplesAddr(_ plot: Int) -> DMCPAddress? {
        return offsetByArg(firstPlotCapturedSamplesAddr!, fileBy: plot)
    }
    
    public static var firstPlotTriggerTimeAddr: DMCPAddress? = DMCPAddress(512,12)
    public static func plotTriggerTimeAddr(_ plot: Int) -> DMCPAddress? {
        return offsetByArg(firstPlotTriggerTimeAddr!, fileBy: plot)
    }
    
    public static var firstPlotTriggerIndexAddr: DMCPAddress? = DMCPAddress(512,13)
    public static func plotTriggerIndexAddr(_ plot: Int) -> DMCPAddress? {
        return offsetByArg(firstPlotTriggerIndexAddr!, fileBy: plot)
    }
    
    public static var firstPlotDataSetsAddressesAddr: DMCPAddress? = DMCPAddress(512,16)
    public static func plotDataSetsAddressesAddr(_ plot: Int) -> DMCPAddress? {
        return offsetByArg(firstPlotDataSetsAddressesAddr!, fileBy: plot)
    }
    
    public static var staticPlotReadMaxPlots = 4
    public static var staticPlotReadMaxDataSets = 16
    public static var firstPlotStaticUploadAreaAddr: DMCPAddress? = DMCPAddress(640,0)
    public static func plotStaticUploadAreaAddr(forPlot plot: Int, dataSet: Int) -> DMCPAddress? {
        var address = firstPlotStaticUploadAreaAddr
        address!.file += UInt16(4 * plot + dataSet)
        return address
    }
    
    
    // NOTE: Could be wrong
    public static var firstPlotDynamicUploadModeStatusAddr: DMCPAddress? = DMCPAddress(576,0)
    public static func plotDynamicUploadModeStatusAddr(forPlot plot: Int) -> DMCPAddress? {
        offsetByArg(firstPlotDynamicUploadModeStatusAddr!, fileBy: plot)
    }
    
    public static var firstPlotDynamicRequestedReadSamplesAddr: DMCPAddress? = DMCPAddress(576,1)
    public static func plotDynamicRequestedReadSamplesAddr(forPlot plot: Int) -> DMCPAddress? {
        offsetByArg(firstPlotDynamicRequestedReadSamplesAddr!, fileBy: plot)
    }
    
    public static var firstPlotDynamicCurrentIndexAddr: DMCPAddress? = DMCPAddress(576,2)
    public static func plotDynamicCurrentIndexAddr(forPlot plot: Int) -> DMCPAddress? {
        offsetByArg(firstPlotDynamicCurrentIndexAddr!, fileBy: plot)
    }
    
    public static var firstPlotDynamicIDAddr: DMCPAddress? = DMCPAddress(576,3)
    public static func plotDynamicIDAddr(forPlot plot: Int) -> DMCPAddress? {
        offsetByArg(firstPlotDynamicIDAddr!, fileBy: plot)
    }
    
    public static var firstPlotDynamicSamplesUploadedAddr: DMCPAddress? = DMCPAddress(576,4)
    public static func plotDynamicSamplesUploadedAddr(forPlot plot: Int) -> DMCPAddress? {
        offsetByArg(firstPlotDynamicSamplesUploadedAddr!, fileBy: plot)
    }
    
    public static var firstPlotDynamicDataAddr: DMCPAddress? = DMCPAddress(576,5)
    public static func plotDynamicDataAddr(forPlot plot: Int) -> DMCPAddress? {
        offsetByArg(firstPlotDynamicDataAddr!, fileBy: plot)
    }
}
